' OVAL constants

' Show method parameters
Global Const OV_MODAL = 1
Global Const OV_MODELESS = 0

'ZOrder method parameters
Global Const OV_BRING_TO_FRONT = 0
Global Const OV_SEND_TO_BACK = 1

' Key Codes
'
Global Const OV_KEY_UP = 256
Global Const OV_KEY_DOWN = 257
Global Const OV_KEY_LEFT = 259
Global Const OV_KEY_RIGHT = 258
Global Const OV_KEY_DIAMOND = 292
Global Const OV_KEY_ESC = 27
Global Const OV_KEY_ENTER = 13
Global Const OV_KEY_DEL = 8
Global Const OV_KEY_MENU = 290
Global Const OV_KEY_TAB = 9
Global Const OV_KEY_MOD_SHIFT = &H2
Global Const OV_KEY_MOD_CONTROL = &H4
Global Const OV_KEY_MOD_PSION = &H8
Global Const OV_KEY_MOD_CAPS = &H10

' VarType tags

Global Const OV_EMPTY = 0
Global Const OV_NULL = 1
Global Const OV_INTEGER = 2
Global Const OV_LONG = 3
Global Const OV_SINGLE = 4
Global Const OV_DOUBLE = 5
Global Const OV_CURRENCY = 6
Global Const OV_DATE = 7
Global Const OV_STRING = 8


' Event Parameters
' QueryUnload
Global Const QUREASON_CODE = 1
Global Const QUREASON_SHELL = 3


' Properties

' Colours
Global Const BLACK = &H0&
Global Const RED = &HFF&
Global Const GREEN = &HFF00&
Global Const YELLOW = &HFFFF&
Global Const BLUE = &HFF0000
Global Const MAGENTA = &HFF00FF
Global Const CYAN = &HFFFF00
Global Const WHITE = &HFFFFFF


' Enumerated Types

' Command control
' Hotkey
Global const CMD_KEY_Enter=0
Global const CMD_KEY_Esc=1
Global const CMD_KEY_Del=2
Global const CMD_KEY_Space=3
Global const CMD_KEY_Up=4
Global const CMD_KEY_Down=5
Global const CMD_KEY_Right=6
Global const CMD_KEY_Left=7
Global const CMD_KEY_Tab=8
Global const CMD_KEY_A=9
Global const CMD_KEY_B=10
Global const CMD_KEY_C=11
Global const CMD_KEY_D=12
Global const CMD_KEY_E=13
Global const CMD_KEY_F=14
Global const CMD_KEY_G=15
Global const CMD_KEY_H=16
Global const CMD_KEY_I=17
Global const CMD_KEY_J=18
Global const CMD_KEY_K=19
Global const CMD_KEY_L=20
Global const CMD_KEY_M=21
Global const CMD_KEY_N=22
Global const CMD_KEY_O=23
Global const CMD_KEY_P=24
Global const CMD_KEY_Q=25
Global const CMD_KEY_R=26
Global const CMD_KEY_S=27
Global const CMD_KEY_T=28
Global const CMD_KEY_U=29
Global const CMD_KEY_V=30
Global const CMD_KEY_W=31
Global const CMD_KEY_X=32
Global const CMD_KEY_Y=33
Global const CMD_KEY_Z=34

'Line control
'DrawMode
Global const LINE_DRAWMODE_Clear=0
Global const LINE_DRAWMODE_Normal=1
Global const LINE_DRAWMODE_Invert=2

'Serial control
'Speed
Global const SERIAL_SPEED_50=0
Global const SERIAL_SPEED_75=1
Global const SERIAL_SPEED_110=2
Global const SERIAL_SPEED_134=3
Global const SERIAL_SPEED_150=4
Global const SERIAL_SPEED_300=5
Global const SERIAL_SPEED_600=6
Global const SERIAL_SPEED_1200=7
Global const SERIAL_SPEED_1800=8
Global const SERIAL_SPEED_2000=9
Global const SERIAL_SPEED_2400=10
Global const SERIAL_SPEED_3600=11
Global const SERIAL_SPEED_4800=12
Global const SERIAL_SPEED_7200=13
Global const SERIAL_SPEED_9600=14
Global const SERIAL_SPEED_19200=15
Global const SERIAL_SPEED_38400=16
Global const SERIAL_SPEED_56000=17
Global const SERIAL_SPEED_57600=17
Global const SERIAL_SPEED_115000=18
Global const SERIAL_SPEED_115200=18

'ParityType
Global const SERIAL_PARITY_TYPE_Even=0
Global const SERIAL_PARITY_TYPE_Odd=1
Global const SERIAL_PARITY_TYPE_Mark=2
Global const SERIAL_PARITY_TYPE_Space=3

'LatLong control
'Type
Global const LATLONG_TYPE_Latitude=0
Global const LATLONG_TYPE_Longitude=1

'Link control
'Speed
Global const LINK_SPEED_50=0
Global const LINK_SPEED_75=1
Global const LINK_SPEED_110=2
Global const LINK_SPEED_134=3
Global const LINK_SPEED_150=4
Global const LINK_SPEED_300=5
Global const LINK_SPEED_600=6
Global const LINK_SPEED_1200=7
Global const LINK_SPEED_1800=8
Global const LINK_SPEED_2000=9
Global const LINK_SPEED_2400=10
Global const LINK_SPEED_3600=11
Global const LINK_SPEED_4800=12
Global const LINK_SPEED_7200=13
Global const LINK_SPEED_9600=14
Global const LINK_SPEED_19200=15
Global const LINK_SPEED_38400=16

'Cradle control
'ChargeMode
Global const CRADLE_CHARGE_MODE_Current850=0
Global const CRADLE_CHARGE_MODE_Current500=1
Global const CRADLE_CHARGE_MODE_Current200=2

'Machine control
'Reasons for switch off (not enum)
Global Const OFF_KEY     = 0
Global Const OFF_AUTO    = 1
Global Const OFF_BATTERY = 2

'Machine control
'Architecture (not enum)
Global Const ARCH_SIBO = 1
Global Const ARCH_ERA  = 2

'AutoSwitchOff (not enum)
Global Const AUTOOFF_YES         = 1
Global Const AUTOOFF_NO          = 2
Global Const AUTOOFF_NO_EXTERNAL = 3

'BatteryStatus (not enum)
Global Const BATTERY_GOOD        = 3
Global Const BATTERY_LOW         = 2
Global Const BATTERY_VERY_LOW    = 1
Global Const BATTERY_ZERO        = 0

'BatteryType (not enum)
Global Const BATTERY_UNKNOWN     = 0
Global Const BATTERY_ALKALINE    = 1
Global Const BATTERY_NICAD_600   = 2
Global Const BATTERY_NICAD_1000  = 3
Global Const BATTERY_NICAD_500   = 4
Global Const BATTERY_NICAD_850   = 5

'Language (not enum)
Global Const LANG_TEST           = 0
Global Const LANG_ENGLISH        = 1
Global Const LANG_FRENCH         = 2
Global Const LANG_GERMAN         = 3
Global Const LANG_SPANISH        = 4
Global Const LANG_ITALIAN        = 5
Global Const LANG_SWEDISH        = 6
Global Const LANG_DANISH         = 7
Global Const LANG_NORWEGIAN      = 8
Global Const LANG_FINNISH        = 9
Global Const LANG_USA            = 10
Global Const LANG_SFRENCH        = 11
Global Const LANG_SGERMAN        = 12
Global Const LANG_PORTUGUESE     = 13
Global Const LANG_TURKISH        = 14
Global Const LANG_ICELANDIC      = 15
Global Const LANG_RUSSIAN        = 16
Global Const LANG_HUNGARIAN      = 17
Global Const LANG_DUTCH          = 18
Global Const LANG_FLEMISH        = 19
Global Const LANG_AUSTRALIAN     = 20
Global Const LANG_NEWZEALAND     = 21
Global Const LANG_AUSTRIAN       = 22
Global Const LANG_BFRENCH        = 23


'StatusWin control
'Type
Global const STATUSWIN_TYPE_None=0
Global const STATUSWIN_TYPE_Small=1
Global const STATUSWIN_TYPE_Big=2

'IpcServer/client controls
'Mode
Global const IPC_MODE_C=0
Global const IPC_MODE_OVAL=1

'Clock control
'Mode
Global const CLOCK_MODE_MediumAnalog=0
Global const CLOCK_MODE_MediumDigital=1
Global const CLOCK_MODE_XLargeAnalog=2
Global const CLOCK_MODE_Formatted=3

'Image/PictureBox controls
'DrawMode
Global const IMAGE_DRAW_MODE_Black=0
Global const IMAGE_DRAW_MODE_Grey=1
Global const IMAGE_DRAW_MODE_Both=2

'DateEditor
'TimeFormat
Global const DATE_HHMM=0
Global const DATE_HHMMSS=1
Global const DATE_HHMMD=2
Global const DATE_HHMMSSD=3

' Shape control
Global Const SHAPE_RECTANGLE = 0
Global Const SHAPE_SQUARE = 1
Global Const SHAPE_OVAL = 2
Global Const SHAPE_CIRCLE = 3
Global Const SHAPE_ROUNDED_RECTANGLE = 4
Global Const SHAPE_ROUNDED_SQUARE = 5

'Grid control
'HighlightStyle
Global const GRID_STYLE_None=0
Global const GRID_STYLE_Single=1
Global const GRID_STYLE_Row=2

'HeadingFlags
Global const GRID_HEADING_Invisible=0
Global const GRID_HEADING_Visible=1

' Other Grid constants

Global Const GRID_CENTRE         = 0
Global Const GRID_RIGHT	         = 1
Global Const GRID_LEFT           = 2

Global Const GRID_INTEGER        = 2        'VB types coincide with Type no's
Global Const GRID_LONG           = 3
Global Const GRID_DOUBLE         = 5
Global Const GRID_CURRENCY       = 6
Global Const GRID_DATE           = 7
Global Const GRID_STRING         = 8
Global Const GRID_TRUEFALSE      = 9
Global Const GRID_YESNO          = 10
Global Const GRID_YN             = 11
Global Const GRID_CHECKBOX       = 12


'Enumerations for standard properties

' Form - BorderShadow
Global const BORDER_SHADOW_Auto = 0
Global const BORDER_SHADOW_On = 1
Global const BORDER_SHADOW_Off = 2

'Form - BorderStyle
Global const BORDER_STYLE_NoBorder = 0
Global const BORDER_STYLE_NoShadow = 1
Global const BORDER_STYLE_NarrowShadow = 2
Global const BORDER_STYLE_WideShadow =3
Global const BORDER_STYLE_Narrow3d =4
Global const BORDER_STYLE_Wide3d =5

'Form - BorderRound
Global const BORDER_ROUND_Least = 0
Global const BORDER_ROUND_Middle = 1
Global const BORDER_ROUND_Most = 2

'Clip
'Global const CLIP_Auto = 0
'Global const CLIP_Yes = 1
'Global const CLIP_No = 2


' Other runtime constants

' OVAL file handling flags
Global const OV_FILE_ID_MIN =   1       ' Lowest  file identification number
Global const OV_FILE_ID_MAX =   255     ' Highest file identification number
Global const OV_FILEATTR_MASK = &H3f    ' Flags &H40 upwards are undefined  
Global const OV_DIRFATTR_MASK = &H1e    ' Flags allowed in DIR keyword      

' SetAttr, Dir, GetAttr functions
Global Const ATTR_NORMAL = 0
Global Const ATTR_READONLY = 1
Global Const ATTR_HIDDEN = 2
Global Const ATTR_SYSTEM = 4
Global Const ATTR_VOLUME = 8
Global Const ATTR_DIRECTORY = 16
Global Const ATTR_ARCHIVE = 32

' OVAL file mode flags which match FileAttr numbers 
Global const OV_FM_INPUT =    1
Global const OV_FM_OUTPUT =   2
Global const OV_FM_RANDOM =   4
Global const OV_FM_APPEND =   8
' Global const UNUSED =       16
Global const OV_FM_BINARY =   32
Global const OV_FM_SEQUENTIAL = OV_FM_INPUT or OV_FM_OUTPUT or OV_FM_APPEND

' Error codes
Global const ERR_NO_ERR = 0 
Global const ERR_RET_NO_GOSUB = 3             ' Return without GoSub 
Global const ERR_ILLEGAL_FUNCTION_CALL = 5    ' Illegal function call 
Global const ERR_OVERFLOW = 6                 ' Overflow 
Global const ERR_OUT_OF_MEMORY = 7            ' Out of memory 
Global const ERR_INDX_OUT_OF_BOUNDS = 9       ' Subscript out of range 
Global const ERR_DIVIDE_0 = 11                ' Division by zero 
Global const ERR_TYPE_MISMATCH = 13           ' Type mismatch 
Global const ERR_OUT_OF_STRING_SPACE = 14     ' Out of string space 
Global const ERR_NO_RESUME = 19               ' No Resume 
Global const ERR_RESUME_NO_ERR = 20           ' Resume without error 
Global const ERR_OUT_OF_STACK_SPACE = 28      ' Out of stack space 
Global const ERR_INTERNAL = 51                ' Internal error 
Global const ERR_BAD_FILE_NUMBER = 52         ' Bad file name or number 
Global const ERR_FILE_NOT_FOUND = 53          ' File not found 
Global const ERR_BAD_FILE_MODE = 54           ' Bad file mode 
Global const ERR_FILE_ALREADY_OPEN = 55       ' File already open 
Global const ERR_IO = 57                      ' Device I/O error 
Global const ERR_FILE_ALREADY_EXISTS = 58     ' File already exists 
Global const ERR_BAD_RECORD_LENGTH = 59       ' Bad record length 
Global const ERR_DISK_FULL = 61               ' Disk full 
Global const ERR_INPUT_PAST_EOF = 62          ' Input past end of file 
Global const ERR_TOO_MANY_FILES = 67          ' Too many files 
Global const ERR_INVALID_DRIVE = 68           ' Device unavailable 
Global const ERR_ACCESS_DENIED = 70           ' Permission denied 
Global const ERR_DISK_NOT_READY = 71          ' Disk not ready 
Global const ERR_FILE_ACCESS = 75             ' Path/File access error 
Global const ERR_PATH_NOT_FOUND = 76          ' Path not found 
Global const ERR_OBJECT_VARIABLE_NOT_SET = 91 ' Object variable not Set 
Global const ERR_PATTERN_INVALID = 93         ' Invalid pattern string 
Global const ERR_INVALID_USE_OF_NULL = 94     ' Invalid use of Null 
Global const ERR_INVALID_FILE_FORMAT = 321    ' Invalid file format 
Global const ERR_CA_ELEMENT_NOT_EXIST = 340   ' Control array element ' ' doesn't exist 
Global const ERR_INVALID_CA_INDEX = 341       ' Invalid control array index 
Global const ERR_OBJ_NOT_ARRAY = 343          ' Object not an array 
Global const ERR_NO_INDEX_FOR_ARRAY = 344     ' Must specify index for object array 
Global const ERR_OBJ_ALREADY_LOADED = 360     ' Object already loaded 
Global const ERR_CANT_UNLOAD_CONTROL = 362    ' Can't unload controls created at design time 
Global const ERR_CANT_UNLOAD = 365            ' Unable to unload within this context 
Global const ERR_INVALID_PROPERTY_VALUE = 380 ' Invalid property value 
Global const ERR_INVALID_ARRAY_INDEX = 381    ' Invalid property array index 
Global const ERR_PROPERTY_READ_ONLY = 383     ' ' ' property is read-only 
Global const ERR_NEED_INDEX = 385             ' Must specify index when using property array 
Global const ERR_NOT_RT_PROP = 386            ' ' ' property not available at run time 
Global const ERR_PROPERTY_WRITE_ONLY = 394    ' ' ' property is write-only 
Global const ERR_PROPERTY_NOT_FOUND = 422     ' Property ' ' not found 
Global const ERR_PROP_CONTROL_NOT_FOUND = 423 ' Property or control ' ' not found 

Global const ERR_DA_INV_ARG =  3001           ' Invalid argument.
Global const ERR_DA_SESSION =  3002           ' Couldn't start session.
Global const ERR_DA_DB_EXLOCKED =  3006       ' Database ' ' is exclusively locked.
Global const ERR_DA_TB_EXLOCKED =  3008       ' Table ' ' is exclusively locked.
Global const ERR_DA_TB_IN_USE =  3009         ' Couldn't lock table ' '; currently in use.
Global const ERR_DA_TB_EXISTS =  3010         ' Table ' ' already exists.
Global const ERR_DA_OBJ_NOT_FOUND =  3011     ' Couldn't find object ' '
Global const ERR_DA_TB_NOT_INDEX =  3015      ' ' ' isn't an index in this table.
Global const ERR_DA_FLD_TOO_LONG =  3017      ' Field length is too long.
Global const ERR_DA_FLD_NOT_FOUND =  3018     ' Couldn't find field ' '.
Global const ERR_DA_INV_NO_INDEX =  3019      ' Operation invalid without a current index.
Global const ERR_DA_BAD_UPDATE =  3020        ' Update without AddNew or Edit.
Global const ERR_DA_NO_RECORD =  3021         ' No current record.
Global const ERR_DA_DUPLICATE =  3022         ' Can't have duplicate key; index changes were unsuccessful.
Global const ERR_DA_ADD_EDIT =  3023          ' AddNew or Edit already used.
Global const ERR_DA_FILE_NOT_FOUND =  3024    ' Couldn't find file ' '.
Global const ERR_DA_NO_DISK_SPACE =  3026     ' Not enough space on disk.
Global const ERR_DA_DB_READ_ONLY =  3027      ' Couldn't update; database is read-only.
Global const ERR_DA_DISK_IO =  3040           ' Disk I/O error during read.
Global const ERR_DA_INV_PATH =  3044          ' ' ' isn't a valid path.
Global const ERR_DA_LOCKED =  3046            ' Couldn't save; currently locked by another user.
Global const ERR_DA_FILE_OPEN_FAIL =  3051    ' Couldn't open file ' '.
Global const ERR_DA_BIND_NAME =  3070         ' Can't bind name ' '.
Global const ERR_DA_NO_UPDATE =  3113         ' Can't update ' '; field not updatable.
Global const ERR_DA_NAME =  3125              ' Not a valid name.
Global const ERR_DA_ODBC_FAIL =  3146         ' ODBC - call failed
Global const ERR_DA_BMARK =  3159             ' Not a valid bookmark.
Global const ERR_DA_INV_NULL =  3162          ' Null is invalid.
Global const ERR_DA_DATA_TOO_LONG =  3163     ' Couldn't insert or paste; data too long for field
Global const ERR_DA_ISAM =  3170              ' Couldn't find installable ISAM.
Global const ERR_DA_FLD_TWICE =  3191         ' Can't define field more than once.
Global const ERR_DA_DB_EXISTS =  3204         ' Database already exists.
Global const ERR_DA_UPDATE_LOCKED =  3218     ' Couldn't update; currently locked.
Global const ERR_DA_ILLEGAL =  3219           ' Can't perform operation; it is illegal.
Global const ERR_DA_BAD_KEY =  3250           ' Couldn't build key.
Global const ERR_DA_TYPE =  3259              ' Invalid field data type.
Global const ERR_DA_NO_FIELDS =  3264         ' No fields defined - cannot append table.
Global const ERR_DA_NOT_FOUND =   3265        ' Name not found in this collection.
Global const ERR_DA_FLD_APPEND =   3266       ' Append illegal - Field is part of a TableDefs collection.
Global const ERR_DA_FLD_PROPERTY =   3267     ' Property value only valid when Field is part of a recordset.
Global const ERR_DA_DB_PROPERTY =   3268      ' Cannot set the property of an object which is part of a Database object.
Global const ERR_DA_IDX_APPEND =   3269       ' Append illegal - Index is part of a TableDefs collection.
Global const ERR_DA_METHOD =   3273           ' Method not applicable for this object.
Global const ERR_DA_PRIMARY =   3283          ' Primary key already exists.
Global const ERR_DA_IDX_EXISTS =   3284       ' Index already exists.
Global const ERR_DA_SYNTAX =   3290           ' Syntax error.
Global const ERR_GRID_INVALID_ROW = 30009     ' Invalid row value
Global const ERR_GRID_INVALID_COLUMN = 30010  ' Invalid column value
Global const ERR_GRID_DB_ERROR = 30011        ' Grid/database synchronisation error

' Keyword arguments
' Format constant
Global Const GeneralNumber = ""
Global Const Currency_fmt  = "#,##0.00;(#,##0.00)" '"Currency" is a reserved word
Global Const Fixed         = "0.00"
Global Const Standard      = "#,##0.00"
Global Const Percent       = "0.00%"
Global Const Scientific    = "0.00E+00"
Global Const YesNo         = """Yes"";""Yes"";""No""" 
Global Const TrueFalse     = """True"";""True"";""False""" 
Global Const OnOff         = """On"";""On"";""Off"""
 
Global Const GeneralDate   = "c"
Global Const LongDate      = "dddddd"
Global Const MediumDate    = "dd-mmm-yy"
Global Const ShortDate     = "ddddd"
Global Const LongTime      = "ttttt"
Global Const MediumTime    = "hh:nn AM/PM"
Global Const ShortTime     = "hh:nn"
 
' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

'Not available in OVAL
'Global Const MB_ICONSTOP = 16          ' Critical message
'Global Const MB_ICONQUESTION = 32      ' Warning query
'Global Const MB_ICONEXCLAMATION = 48   ' Warning message
'Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_APPLMODAL = 0          ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      'System Modal

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed


'---------------------------------------------------------------------------
'InfoMsg and SetBusyMsg Corner parameters
'
Global Const W_CORNER_TOP_LEFT     =  &H00
Global Const W_CORNER_TOP_RIGHT    =  &H80
Global Const W_CORNER_BOTTOM_LEFT  =  &H40
Global Const W_CORNER_BOTTOM_RIGHT =  &HC0

'---------------------------------------------------------------------------
' File and I/O system definitions
'
Global Const P_MAXDEVNAME = 4

'IoOpen service mode flags
Global Const P_FOPEN = &H0000 ' Open i/o service
Global Const P_FCREATE = &H0001 ' Create file 
Global Const P_FREPLACE = &H0002 ' Replace file 
Global Const P_FAPPEND = &H0003 ' Append records 
Global Const P_FUNIQUE = &H0004 ' Unique file open 
Global Const P_FSER_MASK = &H000f ' File service mask 

Global Const P_FSTREAM = &H0000 ' Stream access to a binary file 
Global Const P_FSTREAM_TEXT = &H0010 ' Stream access to a text file 
Global Const P_FTEXT = &H0020 ' Record access to a text file 
Global Const P_FDIR = &H0030 ' Record access to a directory file 
Global Const P_FFORMAT = &H0040 ' Format a device 
Global Const P_FDEVICE = &H0050 ' Record access to device name list 
Global Const P_FNODE = &H0060 ' Record access to node name list 
Global Const P_FMT_MASK = &H00f0 ' File format mask 

Global Const P_FUPDATE = &H0100 ' Read and write access 
Global Const P_FRANDOM = &H0200 ' Random access 
Global Const P_FSHARE = &H0400 ' File can be shared 
Global Const P_FACC_MASK = &H0f00 ' mask for access types 

Global Const P_FLOWDENSITY   = &H1000

' p_io/p_iow function constants 
' Generic I/O functions 
Global Const P_FREAD = 1 ' Read 
Global Const P_FWRITE = 2 ' Write 
Global Const P_FCLOSE = 3 ' Close 
Global Const P_FCANCEL = 4 ' Cancel io 
Global Const P_FATTACH = 5 ' attach this pseudo device 
Global Const P_FDETACH = 6 ' detach this pseudo device 
Global Const P_FSET = 7 ' set channel characteristics 
Global Const P_FSENSE = 8 ' sense channel characteristics 
Global Const P_FFLUSH = 9 ' Flush buffers 

' Now follows the device specific functions 

' Timer device driver 
Global Const P_FRELATIVE = P_FREAD ' Relative timer 
Global Const P_FABSOLUTE = P_FWRITE ' Absolute timer 

' Files 
Global Const P_FSEEK = 10 ' Seek 
Global Const P_FSETEOF = 11 ' Set end of file 

' Data Link I/O + wserv 
Global Const P_FCONNECT = 10 ' Queue a link connect request 
Global Const P_FDISCONNECT = 11 ' Disconnect the link 

' Serial/llmac 
Global Const P_FTEST = 10 ' return no. of bytes in serial receieve buffer 
Global Const P_FCTRL = 11 ' serial port control lines 
Global Const P_FINQ = 12 ' inquire of device capabilities 
Global Const P_FRSUPER = 13 ' read a supervisory frame (p_llmac) 
Global Const P_FSTOP = 14 ' stop LLMAC mode 
Global Const P_FSTART = 15 ' start LLMAC mode 

' Serial LDD to Serial PDD I/O defines 
Global Const P_FENABLE = 16 ' Enable transmit interrupts 
Global Const P_FSETINT = 17 ' set the serial Interrupt code ptrs 

' modem functions 
Global Const P_FMINIT = 16 ' modem initialization function 
Global Const P_FMDIAL = 17 ' modem dial function 
Global Const P_FMWAITCALL = 18 ' wait for an incoming call 
Global Const P_FMSENSE = 19 ' Sense Modem characteristics 
Global Const P_FMSET = 20 ' Set Modem characteristics 
Global Const P_FMCANCEL = 21 ' Cancel outstanding mode request 
Global Const P_FMWRITE = 22 ' Write a configuration string to modem with timeout 

' p_seek() mode constants 
Global Const P_FABS = 1 ' Position absolute in the file 
Global Const P_FEND = 2 ' Position relative from the end of file 
Global Const P_FCUR = 3 ' Position relative to the current pos 
Global Const P_FRSENSE = 4 ' Sense the record position 
Global Const P_FRSET = 5 ' Set the record position 
Global Const P_FREWIND = 6 ' Rewind a text file 

Global Const P_MAXDEV = 128 ' Maximum device name size 
Global Const P_MAXPATH = 128 ' Maximum path size 
Global Const P_MAXNAME = 128 ' Maximum name size 
Global Const P_MAXEXTN = 128 ' Maximum extension size 
Global Const P_FNAMESIZE = 128 ' Maximum file name size 

'---------------------------------------------------------------------------
' Epoc errors
' Epoc errors are generally mapped to regular OVAL errors
' The following correspond to standard Epoc error codes
' for which no mapping applies
' To find the corresponding EPOC error code, subtract 31000 and negate
' e.g. 31001 => epoc error -1
'
Global Const E_GEN_FAIL = 31001
Global Const E_GEN_NSUP = 31004
Global Const E_GEN_RANGE = 31007

Global Const E_GEN_NOSEGMENTS = 31011
Global Const E_GEN_NOSEM = 31012
Global Const E_GEN_NOPROC = 31013
Global Const E_GEN_OPEN = 31014
Global Const E_GEN_NOTOPEN = 31015
Global Const E_GEN_IMAGE = 31016
Global Const E_GEN_RECEIVER = 31017
Global Const E_GEN_DEVICE = 31018
Global Const E_GEN_FSYS = 31019
Global Const E_GEN_START = 31020
Global Const E_GEN_NOFONT = 31021
Global Const E_GEN_TOOWIDE = 31022
Global Const E_GEN_TOOMANY = 31023
Global Const E_GEN_BATSOUND = 31024
Global Const E_GEN_BATFLASH = 31025

' file errors 
'
Global Const E_FILE_PENDING    = 31046 ' I/O pending (not yet completed) 
Global Const E_FILE_VOLUME     = 31047 ' Invalid volume 
Global Const E_FILE_CANCEL     = 31048 ' Async operation was cancelled 
Global Const E_FILE_DISC       = 31050 ' link is disconnected 
Global Const E_FILE_CONNECT    = 31051 ' link already connected 
Global Const E_FILE_RETRAN     = 31052 ' Retransmission threshold exceeded 
Global Const E_FILE_LINE       = 31053 ' Physical link failure 
Global Const E_FILE_INACT      = 31054 ' Inactivity timer expired 
Global Const E_FILE_PARITY     = 31055 ' Serial parity error 
Global Const E_FILE_FRAME      = 31056 ' Serial framing error 
Global Const E_FILE_OVERRUN    = 31057 ' Serial overrun error 
Global Const E_MDM_CONFAIL     = 31058 ' modem can't connect to remote modem 
Global Const E_MDM_BUSY        = 31059 ' remote number busy 
Global Const E_MDM_NOANS       = 31060 ' there was no answer 
Global Const E_MDM_BLACKLIST   = 31061 ' number blacklisted by the modem
Global Const E_FILE_NOTREADY   = 31062 ' Drive not ready error 
Global Const E_FILE_UNKNOWN    = 31063 ' Unknown media in drive 
Global Const E_FILE_DIRFULL    = 31064 ' Root dir full error 
Global Const E_FILE_PROTECT    = 31065 ' Device write protect 
Global Const E_FILE_CORRUPT    = 31066 ' Media is corrupt 
Global Const E_FILE_ABORT      = 31067 ' User aborted operation error 
Global Const E_FILE_ERASE      = 31068 ' Failed to Erase Flash pack 

'ParseFile
Global Const PARSE_NAME_WILD = &h1
Global Const PARSE_EXT_WILD = &h2

'GC object
'
'GC TWidth
Global Const GTWIDTH_MAX_LEN = 255

'GMode and TextMode
Global Const G_TRMODE_SET = 0
Global Const G_TRMODE_CLR = 1 
Global Const G_TRMODE_INV = 2
'GC TextMode and Copy/Patt
Global Const G_TRMODE_REPL = 4


'GC Style
Global Const G_STY_NORMAL = 0
Global Const G_STY_BOLD = &H01
Global Const G_STY_UNDERLINE = &H02
Global Const G_STY_INVERSE = &H04
Global Const G_STY_DOUBLE = &H08
Global Const G_STY_MONO = &H10
Global Const G_STY_ITALIC = &H20
Global Const G_STY_SUBSCRIPT2 = &H40
Global Const G_STY_SUPERSCRIPT2 = &H80
Global Const G_STY_SUBSCRIPT = &H100
Global Const G_STY_SUPERSCRIPT = &H200

Global Const G_GC_FLAG_NORMAL        = 0
Global Const G_GC_FLAG_GREY_PLANE    = &H1
Global Const G_GC_FLAG_BOTH_PLANES   = &H2
Global Const G_GC_FLAG_DOUBLE        = &H4


'GC font info
Global Const G_FONT_FLAG_ASCII   = &H01
Global Const G_FONT_FLAG_CP850   = &H02
Global Const G_FONT_FLAG_BOLD    = &H04
Global Const G_FONT_FLAG_ITALIC  = &H08
Global Const G_FONT_FLAG_SERIF   = &H10
Global Const G_FONT_FLAG_MONO    = &H20

'GC font ids
Global Const WS_FONT_BASE       = &H4000
Global Const WS_FONT_S3Normal   = &H4000
Global Const WS_FONT_S3Bold     = &H4001
Global Const WS_FONT_SmallDig   = &H4002
Global Const WS_FONT_Mono8x8    = &H4003
Global Const WS_FONT_Roman8     = &H4004
Global Const WS_FONT_Roman11    = &H4005
Global Const WS_FONT_Roman13    = &H4006
Global Const WS_FONT_Roman16    = &H4007
Global Const WS_FONT_Swiss8     = &H4008
Global Const WS_FONT_Swiss11    = &H4009
Global Const WS_FONT_Swiss13    = &H400A
Global Const WS_FONT_Swiss16    = &H400B
Global Const WS_FONT_Mono6x6    = &H400C


'GC XPrint
Global Const G_XP_INV_BLOCK  = &H01
Global Const G_XP_INV_OBLOID = &H02
Global Const G_XP_UND_BLOCK  = &H04
Global Const G_XP_REDUCED    = &H08



'Opl errors (as potentially returned by EVALUATE)
'
Global Const E_RUN_ILLEGAL = 31096
Global Const E_RUN_UNDEF = 31098
Global Const E_RUN_NOFLD = 31100
Global Const E_RUN_MODLOAD = 31104
Global Const E_RUN_MAXMOD = 31105
Global Const E_RUN_NOMOD = 31106
Global Const E_RUN_NEWVER = 31107
Global Const E_RUN_MOD_NL = 31108
Global Const E_RUN_TYVIOL = 31110
Global Const E_RUN_SUBS = 31111
Global Const E_RUN_STRTL = 31112
Global Const E_RUN_DEVOP = 31113
Global Const E_RUN_ESC = 31114
Global Const E_RUN_NEWODBVER = 31115
Global Const E_RUN_ODBOPEN = 31116
Global Const E_RUN_MAXDRAW = 31117
Global Const E_RUN_DRAW_NOT_OPEN = 31118
Global Const E_RUN_INVALID_WINDOW = 31119
Global Const E_RUN_SCREEN_DENIED = 31120


'Database Server constants
'
Global Const DB_DENYWRITE    = &H01
Global Const DB_DENYREAD      = &H02
Global Const DB_READONLY      = &H04
Global Const DB_APPENDONLY    = &H08

Global Const DB_UNIQUE       = &H01
Global Const DB_PRIMARY      = &H02

Global Const DB_BOOLEAN      = &H01
Global Const DB_BYTE         = &H02
Global Const DB_INTEGER      = &H03
Global Const DB_LONG         = &H04
Global Const DB_CURRENCY     = &H05
Global Const DB_SINGLE       = &H06
Global Const DB_DOUBLE       = &H07
Global Const DB_DATE         = &H08
Global Const DB_TEXT         = &H0a
Global Const DB_LONGBINARY   = &H0b
Global Const DB_MEMO         = &H0c

Global Const DB_UPDATABLEFIELD   = &H20

Global Const DB_SORTUNDEFINED = -1
Global Const DB_SORTGENERAL   = 256


