Dim ScrImage(24) As String
Dim ScrAttr(24) As String
Dim Normal80 As String
Dim curAttr As String


'
'   Current Buffered Text
'

Dim outstr As String
Dim outx As Integer
Dim outlen As Integer

'
'   Flag to indicate that we're ready to run
'
Dim FlagInit As Integer

Dim curx As Integer
Dim cury As Integer

Dim InEscape As Integer     ' Processing an escape seq?
Dim EscString As String     ' String so far

Dim CharHeight As Integer
Dim CharWidth As Integer

Dim CurState As Integer

Dim tgc As gc

Dim FlagRedraw As Integer

Sub AddEscape (ch As Integer)
Dim yDiff As Integer
Dim xDiff As Integer
    Dim c As String
    Dim l As Long

    c = Chr$(ch)
    If EscString = "" And c <> "[" Then
        InEscape = 0
        Exit Sub
    End If

    EscString = EscString + c
    If (LCase$(c) = UCase$(c)) Then
        ' Not a letter ...
        If Len(EscString) > 16 Then InEscape = 0
        Exit Sub
    End If

    Select Case c
    Case "H", "f"
        EscString = Mid$(EscString, 2)
        cury = Val(PopArg(EscString)) - 1
        If (cury < 0) Then cury = 0
        curx = Val(EscString) - 1
        If (curx < 0) Then curx = 0

    Case "K"
        Select Case Val(Mid$(EscString, 2))
        Case 0
            Call erase_eol
        Case 1
            Call erase_bol
        Case 2
            Call erase_line
        End Select

    Case "J"
        Select Case Val(Mid$(EscString, 2))
        Case 0
            Call erase_eos
        Case 1
            Call erase_bos
        Case 2
            Call erase_screen
        End Select

    Case "m"
        EscString = Mid$(EscString, 2)
'        Do
'            Call SetAttr(PopArg(EscString))
'        Loop While EscString <> ""

    Case "A", "B"
        EscString = Mid$(EscString, 2)
        yDiff% = Val(PopArg(EscString))
        If yDiff% = 0 Then yDiff% = 1
        If c = "A" Then yDiff% = 0 - yDiff%
        cury = cury + yDiff%
        If (cury < 0) Then cury = 0

    Case "C", "D"
        EscString = Mid$(EscString, 2)
        xDiff% = Val(PopArg(EscString))
        If xDiff% = 0 Then xDiff% = 1
        If c = "D" Then xDiff% = 0 - xDiff%
        curx = curx + xDiff%
        If (curx < 0) Then curx = 0
        If (curx > 79) Then curx = 79

    End Select

    InEscape = 0
    EscString = ""

End Sub

Sub erase_bol ()

    '------------------------------------------------------------------------
    '   erase_bol
    '
    '   erase from beginning of current line
    '------------------------------------------------------------------------
    Dim wid As Integer
    Dim High As Integer
    Dim cHigh As Integer


    cHigh = CharHeight
    High = cury * CharHeight
    wid = curx * CharWidth

    tgc.At 0, High
    tgc.Fill wid, cHigh, 1

    Mid$(ScrImage(cury + 1), 1, curx + 1) = Space$(curx + 1)
    Mid$(ScrAttr(cury + 1), 1, curx + 1) = String$(curx + 1, "0")

End Sub

Sub erase_bos ()

    '------------------------------------------------------------------------
    '   erase_bos
    '
    '   erase all lines from beginning of screen to and including current
    '------------------------------------------------------------------------
    Dim wid As Integer
    Dim High As Integer
    Dim cHigh As Integer
    Dim Y As Integer
    '------------------------------------------------------------------------
    '   erase from the beginning of the line. if current line is 0, then exit
    '------------------------------------------------------------------------
    Call erase_bol
    If (cury = 0) Then
        Exit Sub
    End If

    '------------------------------------------------------------------------
    '   calculate height of block to erase
    '------------------------------------------------------------------------
    wid = TTY.Width
    cHigh = CharHeight
    High = (cury - 1) * cHigh

    tgc.At 0, 0
    tgc.Fill wid, High, 1

    '------------------------------------------------------------------------
    '   reset screen buffer contents
    '------------------------------------------------------------------------
    For Y% = 1 To cury
        ScrImage(Y%) = Space$(80)
        ScrAttr(Y%) = Normal80
    Next Y%

End Sub

Sub erase_eol ()
'
'   Erase to End of Line
'
    Dim wid As Integer
    Dim High As Integer
    Dim cHigh As Integer
    Dim StartX As Integer

    wid = TTY.Width
    cHigh = CharHeight
    High = cury * CharHeight
    StartX = curx * CharWidth

    tgc.At StartX, High
    tgc.Fill wid - StartX, cHigh, 1

    Mid$(ScrImage(cury + 1), curx + 1, 80 - curx) = Space$(80 - curx)
    Mid$(ScrAttr(cury + 1), curx + 1, 80 - curx) = String$(80 - curx, "0")

End Sub

Sub erase_eos ()
'
'   Erase to end of screen
'
    Dim wid As Integer
    Dim High As Integer
    Dim cHigh As Integer
    Dim StartY As Integer
    Dim Y As Integer
    Call erase_eol

    If (cury = 23) Then Exit Sub

    wid = TTY.Width
    cHigh = CharWidth
    StartY = (cury + 1) * cHigh
    High = 24 * cHigh - StartY

    tgc.At 0, StartY
    tgc.Fill wid, High, 1

    For Y% = cury + 2 To 24
        ScrImage(Y%) = Space$(80)
        ScrAttr(Y%) = Normal80
    Next Y%

End Sub

Sub erase_line ()

'   Erase Line

    Dim wid As Integer
    Dim High As Integer
    Dim cHigh As Integer
    Dim StartX As Integer

    wid = TTY.Width
    cHigh = CharHeight
    High = cury * cHigh

    tgc.At 0, High
    tgc.Fill wid, cHigh, 1


    ScrImage(cury + 1) = Space$(80)
    ScrAttr(cury + 1) = Normal80

End Sub

Sub erase_screen ()
    Dim Y As Integer
    TTY.Cls
    For Y% = 1 To 24
        ScrImage(Y%) = Space$(80)
        ScrAttr(Y%) = Normal80
    Next Y%

End Sub

Function PopArg (s As String) As String
'
'   PopArg takes the next argument (digits up to a ;) and
'   returns it.  It also removes the arg and the ; from
'   the "s"
    Dim i As Integer
    i% = InStr(s, ";")
    If i% = 0 Then
        PopArg = s
        s = ""
        Exit Function
    End If

    PopArg = Left$(s, i% - 1)
    s = Mid$(s$, i% + 1)

End Function

Sub RedrawScreen ()

    Dim oldcur As Integer
    Dim oldattr As String
    Dim Y As Integer
    If FlagInit <> -1 Then Exit Sub

    Set tgc = New gc
    tgc.CreateGC (TTY.Hwnd)
    tgc.Font = WS_FONT_Mono6x6

    oldcur = CurState
    oldattr = curAttr

    Call hide_cursor

    For Y% = 1 To 20
        tgc.At 0, (Y% - 1) * CharHeight
        tgc.PrintText ScrImage(Y%)
    Next Y%

    If oldcur <> 0 Then Call disp_cursor
    tgc.FreeGC
End Sub

Sub StartEscape ()
    InEscape = -1
    EscString = ""
End Sub

Sub term_put (buf As Variant, cnt As Integer)

    Dim i As Integer
    Dim ch As Integer
    Set tgc = New gc
    tgc.CreateGC TTY.Hwnd
    tgc.Font = WS_FONT_Mono6x6
    
    hide_cursor

    outstr = ""
    outlen = 0
    outx = curx

    For i = 1 To cnt

        ch = &H7F And Asc(Mid$(buf, i, 1))

        If (InEscape) Then
            Call AddEscape(ch)
            outx = curx
        Else
            Select Case ch

            Case 13
                curx = 0
                If (outlen <> 0) Then WriteText
                outx = 0

            Case 10
                If (outlen <> 0) Then WriteText     '   flush output buffer

                cury = cury + 1                     '   goto next line
                If (cury > 23) Then                 '   if line left on scrn
                    Call scroll_up                  '   ..  scroll upwards
                    cury = 23                       '   ..  use blank line
                End If

            Case 8
                If (outlen <> 0) Then WriteText     '   flush output buffer

                If curx > 0 Then                    '   if not at line begin
                    curx = curx - 1                 '   ..  adjust back 1 spc
                    outx = curx
                End If

            Case 7
                Beep

            Case 27
                If (outlen <> 0) Then WriteText
                Call StartEscape

            Case Else
                If (ch > 31) Then
                    outstr = outstr + Chr$(ch)
                    outlen = outlen + 1
                    Mid$(ScrImage(cury + 1), curx + 1, 1) = Chr$(ch)
                    Mid$(ScrAttr(cury + 1), curx + 1, 1) = curAttr
                    curx = curx + 1
                    If (curx >= 80) Then
                        Call WriteText
                        curx = 79
                    End If
                End If
            End Select
        End If
    Next i

    If (outlen <> 0) Then WriteText
    tgc.FreeGC
End Sub

Sub disp_cursor ()

    '------------------------------------------------------------------------
    '   disp_cursor
    '
    
    Dim sx As Integer, sy As Integer
    If CurState Then
        Exit Sub
    End If
    sx% = curx * CharWidth
    sy% = cury * CharHeight
    tgc.At sx%, sy%
    tgc.Fill CharWidth, CharHeight, 0
    CurState = True

End Sub

Sub hide_cursor ()
    Dim sx As Integer
    Dim sy As Integer
    If CurState = 0 Then Exit Sub

    sx% = curx * CharWidth
    sy% = cury * CharHeight

    CurState = False

End Sub

Sub scroll_up ()
    tgc.Grey = 2
    tgc.Scroll 0, -CharHeight
    tgc.At 0, 24 * CharHeight
    tgc.Grey = 0
    tgc.Fill 480, CharHeight, 1
    tgc.Grey = 1
    tgc.At 0, 24 * CharHeight
    tgc.Fill 480, CharHeight, 1
    tgc.Grey = 2
    For i% = 1 To 23
        ScrImage(i%) = ScrImage(i% + 1)
        ScrAttr(i%) = ScrAttr(i% + 1)
    Next i%

    ScrImage(24) = Space$(80)
    ScrAttr(24) = Normal80

End Sub

Sub term_init ()
    Dim i As Integer
    curx = 0
    cury = 0

    CharHeight = 6
    CharWidth = 6
    Set tgc = New gc
    tgc.CreateGC (TTY.Hwnd)
    tgc.Font = WS_FONT_Mono6x6
    InEscape = 0
    CurState = 0

    disp_cursor

    Normal80 = String$(80, "0")

    For i% = 1 To 24
        ScrImage(i%) = Space$(80)
        ScrAttr(i%) = Normal80
    Next i%

    curAttr = "0"

    FlagInit = -1
    tgc.FreeGC
End Sub

Sub WriteText ()
    tgc.At outx * CharWidth, (cury + 1) * CharHeight
    tgc.PrintText Left$(outstr, outlen)
    outstr = ""
    outlen = 0
    outx = outx + outlen
End Sub

