/*
  Clocks application header file
*/

#include <p_std.h>
#include <p_file.h>
#include <p_date.h>
#include <p_config.h>
#include <hasrv.h>
#include <hwim.g>
#include <hwimman.g>
#include <clock.g>
#include <clock.rsg>
#include <hwim.h>
#include <fonts.h>
#include <wldselwn.g>

#define NUM_CLOCKS 8
#define SORT_MANUAL 0
#define SORT_BY_NAME 1
#define SORT_BY_OFFSET 2
#define SORT_BY_NEG_OFFSET 3
#define ALARM_CITY  1
#define ALARM_TIME  2
#define ALARM_DATE  3
#define ALARM_SOUND 4
#define ALARM_TEXT  5
#define HOMETIME 1
#define CALC1    2
#define CITYTIME 3

GLREF_D PR_CLOCKWN* DatApp3;
GLREF_D PR_CLOCK* clocks[NUM_CLOCKS];

GLREF_D TEXT filename[P_FNAMESIZE];

GLREF_D INT homeTime;
GLREF_D INT homeDate;

GLREF_D TEXT homeCity[22];

GLREF_D TEXT alarmText[64];

GLREF_D VOID *world;
GLREF_D VOID *alm;

GLREF_D PR_CLOCKUD *update;
GLREF_D PR_ALARMAO *alarm;

GLREF_D PR_HWIMMAN *const w_am;

GLREF_D INT sort;
GLREF_D INT type;

GLREF_C VOID Sort(INT flag);


