/*

    The loading of an image is performed by the file server (see the Files chapter)

    and the caller must have connected to the file server before calling p_execc

    (otherwise the caller is panicked with panic number 41).  The standard PLIB

    library connects to the file server before calling MAIN.



*/



/*

    The program solicits a line of input and parses out the name to run and

    the text string to pass to the created process ( which is passed with a

    zero terminator ).  If this program is used to run the LINK.IMG then

    entereing: C:\IMG\LINK -b9600 would work.



*/



#include        <plib.h>



LOCAL_C VOID Exec(TEXT *name, TEXT *cmd, INT len)

        {

        INT ret;

        TEXT bb[E_MAX_ERROR_TEXT_SIZE];



        ret=p_execc(name,cmd,len);

        if (ret<0)

           {

           p_errs(&bb[0],ret);

           p_printf("failed to start %s (%s)",name,&bb[0]);

           }



        else

           {

           p_printf("Process ID is %x",ret);

           p_presume(ret);

           }

        }





GLDEF_C INT main(VOID)

        {

        TEXT *p1, *p2;

        TEXT bb[64];



        while (p_getl("Enter <img> <cmd> ? ",&bb[0],64))

              {

              p1=p_skipwh(&bb[0]);

              if (!*p1)

                 continue;

               p2=p_skipch(p1);

               if (*p2)

                  {

                  *p2++='\0';

                  p2=p_skipwh(p2);

                  }

               Exec(p1,p2,p_slen(p2)+1);

             }

           return(0);

         }

